Index: /trunk/Assembly_Library/Inc/CgaSnow.inc
===================================================================
--- /trunk/Assembly_Library/Inc/CgaSnow.inc	(revision 588)
+++ /trunk/Assembly_Library/Inc/CgaSnow.inc	(revision 589)
@@ -1,7 +1,3 @@
-; File name		:	CgaSnow.inc
-; Project name	:	AssemblyLibrary
-; Created date	:	8.10.2010
-; Last update	:	11.10.2010
-; Author		:	Tomi Tilli
+; Project name	:	Assembly Library
 ; Description	:	Macros for preventing CGA snow.
 %ifndef CGASNOW_INC
@@ -9,5 +5,6 @@
 
 ;--------------------------------------------------------------------
-; WAIT_RETRACE_IF_NECESSARY_THEN
+; CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN
+; JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN
 ;	Parameters:
 ;		%1:		Instruction that accessed CGA memory
@@ -22,5 +19,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-%macro WAIT_RETRACE_IF_NECESSARY_THEN 1
+%macro CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN 1
 %ifdef ELIMINATE_CGA_SNOW
 	%ifidn %1, stosb
@@ -31,5 +28,5 @@
 		call	CgaSnow_RepMovsb
 	%else
-		%error	"Invalid instruction passed to WAIT_RETRACE_IF_NECESSARY_THEN"
+		%error	"Invalid instruction passed to CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN"
 	%endif
 %else	; No CGA snow prevention
@@ -38,4 +35,26 @@
 	%else
 		%1	; Single instruction
+	%endif
+%endif
+%endmacro
+
+%macro JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN 1
+%ifdef ELIMINATE_CGA_SNOW
+	%ifidn %1, stosb
+		jmp		CgaSnow_Stosb
+	%elifidn %1, stosw
+		jmp		CgaSnow_Stosw
+	%elifidn %1, rep movsb
+		jmp		CgaSnow_RepMovsb
+	%else
+		%error	"Invalid instruction passed to JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN"
+	%endif
+%else	; No CGA snow prevention
+	%ifidn %1, rep movsb
+		eSEG_STR rep, es, movsb
+		ret
+	%else
+		%1	; Single instruction
+		ret
 	%endif
 %endif
Index: /trunk/Assembly_Library/Inc/DosFunctions.inc
===================================================================
--- /trunk/Assembly_Library/Inc/DosFunctions.inc	(revision 588)
+++ /trunk/Assembly_Library/Inc/DosFunctions.inc	(revision 589)
@@ -9,27 +9,31 @@
 DOS_TSR_MULTIPLEX_INTERRUPT_2Fh						EQU		2Fh
 
-; DOS drive and file functions
-SELECT_DEFAULT_DRIVE								EQU		0Eh
-GET_CURRENT_DEFAULT_DRIVE							EQU		19h
-GET_DISK_TRANSFER_AREA_ADDRESS						EQU		2Fh
-GET_DOS_DRIVE_PARAMETER_BLOCK_FOR_SPECIFIC_DRIVE	EQU		32h
-SET_CURRENT_DIRECTORY								EQU		3Bh
-CREATE_OR_TRUNCATE_FILE								EQU		3Ch
-OPEN_EXISTING_FILE									EQU		3Dh
-CLOSE_FILE											EQU		3Eh
-READ_FROM_FILE_OR_DEVICE							EQU		3Fh
-WRITE_TO_FILE_OR_DEVICE								EQU		40h
-SET_CURRENT_FILE_POSITION							EQU		42h
-GET_CURRENT_DIRECTORY								EQU		47h
-FIND_FIRST_MATCHING_FILE							EQU		4Eh
-FIND_NEXT_MATCHING_FILE								EQU		4Fh
-
-; DOS functions for TSRs
-SET_INTERRUPT_VECTOR								EQU		25h
-GET_INTERRUPT_VECTOR								EQU		35h
+; DOS functions
+WRITE_CHARACTER_TO_STANDARD_OUTPUT					EQU		02h		; DOS 1+
+WRITE_STRING_TO_STANDARD_OUTPUT						EQU		09h		; DOS 1+
+SELECT_DEFAULT_DRIVE								EQU		0Eh		; DOS 1+
+GET_CURRENT_DEFAULT_DRIVE							EQU		19h		; DOS 1+
+SET_INTERRUPT_VECTOR								EQU		25h		; DOS 1+
+GET_DISK_TRANSFER_AREA_ADDRESS						EQU		2Fh		; DOS 2+
+GET_DOS_VERSION										EQU		30h		; DOS 2+
+GET_DOS_DRIVE_PARAMETER_BLOCK_FOR_SPECIFIC_DRIVE	EQU		32h		; DOS 2+
+GET_INTERRUPT_VECTOR								EQU		35h		; DOS 2+
+SET_CURRENT_DIRECTORY								EQU		3Bh		; DOS 2+
+CREATE_OR_TRUNCATE_FILE								EQU		3Ch		; DOS 2+
+OPEN_EXISTING_FILE									EQU		3Dh		; DOS 2+
+CLOSE_FILE											EQU		3Eh		; DOS 2+
+READ_FROM_FILE_OR_DEVICE							EQU		3Fh		; DOS 2+
+WRITE_TO_FILE_OR_DEVICE								EQU		40h		; DOS 2+
+SET_CURRENT_FILE_POSITION							EQU		42h		; DOS 2+
+CHECK_IF_BLOCK_DEVICE_REMOTE						EQU		4409h	; DOS 3.1+
+GET_CURRENT_DIRECTORY								EQU		47h		; DOS 2+
+TERMINATE_WITH_RETURN_CODE							EQU		4Ch		; DOS 2+
+FIND_FIRST_MATCHING_FILE							EQU		4Eh		; DOS 2+
+FIND_NEXT_MATCHING_FILE								EQU		4Fh		; DOS 2+
 
 ; DOS errors
+ERR_DOS_FUNCTION_NUMBER_INVALID						EQU		01h
+ERR_DOS_INVALID_DRIVE								EQU		0Fh
 ERR_DOS_DRIVE_NOT_READY								EQU		15h
-
 
 
Index: /trunk/Assembly_Library/Inc/Emulate.inc
===================================================================
--- /trunk/Assembly_Library/Inc/Emulate.inc	(revision 588)
+++ /trunk/Assembly_Library/Inc/Emulate.inc	(revision 589)
@@ -579,5 +579,15 @@
 
 %macro eRCL_IM 2
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
+%ifdef USE_386
+	%if %2 = 1
+		adc		%1, %1	; Same size but faster on 386 and 486. Fails if %1 is a memory operand.
+	%else
+		eSHIFT_IM	%1, %2, rcl
+	%endif
+%else
 	eSHIFT_IM	%1, %2, rcl
+%endif
+%endif
 %endmacro
 
Index: /trunk/Assembly_Library/Inc/Math.inc
===================================================================
--- /trunk/Assembly_Library/Inc/Math.inc	(revision 588)
+++ /trunk/Assembly_Library/Inc/Math.inc	(revision 589)
@@ -80,5 +80,5 @@
 .ShiftNextBit:
 	eSHL_IM	ax, 1
-	rcl		dx, 1
+	eRCL_IM	dx, 1
 	loop	.ShiftNextBit
 %endmacro
Index: /trunk/Assembly_Library/Inc/SystemTimer.inc
===================================================================
--- /trunk/Assembly_Library/Inc/SystemTimer.inc	(revision 588)
+++ /trunk/Assembly_Library/Inc/SystemTimer.inc	(revision 589)
@@ -1,4 +1,4 @@
 ; Project name	:	Assembly Library
-; Description	:	System Timer (8254) relates equates and macros.
+; Description	:	System Timer (8254) related equates and macros.
 %ifndef SYSTEMTIMER_INC
 %define SYSTEMTIMER_INC
@@ -34,5 +34,5 @@
 CONTROL_WORD_REGISTER_out				EQU	43h
 
-; Timer 2 is connected to PC Speaker that can be controller from port 61h.
+; Timer 2 is connected to PC Speaker that can be controlled from port 61h.
 SPEAKER_CONTROL_REGISTER				EQU	61h
 FLG_TIMER_2_OUTPUT_in					EQU	(1<<5)	; AT+ only
Index: /trunk/Assembly_Library/Src/Display/DisplayCharOut.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayCharOut.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Display/DisplayCharOut.asm	(revision 589)
@@ -41,6 +41,5 @@
 	cmp		al, ' '							; Printable character?
 	jb		SHORT DisplayCharOut_BiosTeletypeOutput
-	WAIT_RETRACE_IF_NECESSARY_THEN stosw
-	ret
+	JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN stosw
 
 ALIGN DISPLAY_JUMP_ALIGN
@@ -96,10 +95,9 @@
 	xchg	al, ah				; Swap character and attribute
 	inc		di					; Skip character
-	WAIT_RETRACE_IF_NECESSARY_THEN stosb
-	ret
+	JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN stosb
 
 ALIGN DISPLAY_JUMP_ALIGN
 DisplayCharOut_Character:
-	WAIT_RETRACE_IF_NECESSARY_THEN stosb
+	CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN stosb
 	inc		di					; Skip attribute
 	ret
@@ -107,6 +105,5 @@
 ALIGN DISPLAY_JUMP_ALIGN
 DisplayCharOut_CharacterWithAttribute:
-	WAIT_RETRACE_IF_NECESSARY_THEN stosw
-	ret
+	JMP_WAIT_FOR_RETRACE_IF_NECESSARY_THEN stosw
 
 
Index: /trunk/Assembly_Library/Src/Display/DisplayFormat.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 589)
@@ -269,7 +269,8 @@
 	jz		SHORT .CopyWithoutDisplayProcessing
 
-	WAIT_RETRACE_IF_NECESSARY_THEN rep movsb
+	CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN rep movsb
 	dec		di					; Point to preceeding character instead of attribute
 	ret
+
 ALIGN DISPLAY_JUMP_ALIGN
 .CopyWithoutDisplayProcessing:
Index: /trunk/Assembly_Library/Src/Display/DisplayPage.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayPage.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Display/DisplayPage.asm	(revision 589)
@@ -43,8 +43,5 @@
 %ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	%define EXCLUDE
-	%ifdef MODULE_HOTKEYS
-		%undef EXCLUDE
-	%endif
-	%ifdef MODULE_BOOT_MENU
+	%ifdef MODULE_HOTKEYS OR MODULE_BOOT_MENU
 		%undef EXCLUDE
 	%endif
Index: /trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 589)
@@ -296,8 +296,5 @@
 		%undef EXCLUDE
 	%endif
-	%ifdef MODULE_HOTKEYS
-		%undef EXCLUDE
-	%endif
-	%ifdef MODULE_BOOT_MENU
+	%ifdef MODULE_HOTKEYS OR MODULE_BOOT_MENU
 		%undef EXCLUDE
 	%endif
Index: /trunk/Assembly_Library/Src/File/Drive.asm
===================================================================
--- /trunk/Assembly_Library/Src/File/Drive.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/File/Drive.asm	(revision 589)
@@ -86,10 +86,10 @@
 	xchg	dx, ax			; Default drive to DL
 	call	Drive_SetDefaultFromDL
-	eMOVZX	cx, al			; Number of potentially valid drive letters available
-	cmp		cl, 32
-	jb		SHORT .Return
-	mov		cl, 32
-ALIGN JUMP_ALIGN, ret
-.Return:
+	cmp		al, 32			; Number of potentially valid drive letters available
+	jb		SHORT .Below32
+	mov		al, 32
+.Below32:
+	cbw
+	xchg	cx, ax
 	ret
 
@@ -133,6 +133,18 @@
 
 	inc		dx			; Default drive is 00h and first drive is 01h
+	mov		ax, CHECK_IF_BLOCK_DEVICE_REMOTE	; Needs DOS 3.1+
+	mov		bx, dx
+	push	dx
+	int		DOS_INTERRUPT_21h
+	pop		dx
+	jnc		SHORT .DriveIsValid
+	cmp		ax, ERR_DOS_INVALID_DRIVE
+	je		SHORT .DriveIsNotValid
+	; Fall back to old method if ERR_DOS_FUNCTION_NUMBER_INVALID
+
 	mov		ah, GET_DOS_DRIVE_PARAMETER_BLOCK_FOR_SPECIFIC_DRIVE
 	int		DOS_INTERRUPT_21h
+.DriveIsValid:
+.DriveIsNotValid:
 	dec		dx
 	test	al, al
Index: /trunk/Assembly_Library/Src/Keyboard/Keyboard.asm
===================================================================
--- /trunk/Assembly_Library/Src/Keyboard/Keyboard.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Keyboard/Keyboard.asm	(revision 589)
@@ -291,8 +291,5 @@
 %ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	%define EXCLUDE
-	%ifdef MODULE_HOTKEYS
-		%undef EXCLUDE
-	%endif
-	%ifdef MODULE_BOOT_MENU
+	%ifdef MODULE_HOTKEYS OR MODULE_BOOT_MENU
 		%undef EXCLUDE
 	%endif
Index: /trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 589)
@@ -162,5 +162,5 @@
 	push	si
 	push	cx
-	WAIT_RETRACE_IF_NECESSARY_THEN rep movsb
+	CALL_WAIT_FOR_RETRACE_IF_NECESSARY_THEN rep movsb
 	pop		cx
 	pop		si
Index: /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 589)
@@ -239,5 +239,5 @@
 ; AppendFileFromDTAinDSSItoOffScreenBuffer
 ;	Parameters:
-;		CX:		Files/directores found
+;		CX:		Files/directories found
 ;		DL:		Zero if root directory selected
 ;		DS:SI:	Ptr to DTA containing file information
Index: /trunk/Assembly_Library/Src/Menu/MenuLoop.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuLoop.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Menu/MenuLoop.asm	(revision 589)
@@ -106,16 +106,7 @@
 %ifndef MENU_NO_ESC
 	cmp		al, ESC
-	je		SHORT .LeaveMenuWithoutSelectingItem
-%endif
-	cmp		al, CR
-	je		SHORT .SelectItem
-
-	test	BYTE [bp+MENU.bFlags], FLG_MENU_USER_HANDLES_SCROLLING
-	jz		SHORT MenuLoop_ProcessScrollingKeysFromAX
-	ret		; Return with CF cleared since keystroke not processed
-
-%ifndef MENU_NO_ESC
-ALIGN MENU_JUMP_ALIGN
-.LeaveMenuWithoutSelectingItem:
+	jne		SHORT .NotEscape
+
+	; Leave menu without selecting item
 	call	MenuEvent_ExitMenu
 	jnc		SHORT .CancelMenuExit
@@ -128,9 +119,20 @@
 
 ALIGN MENU_JUMP_ALIGN
-.SelectItem:
+.NotEscape:
+	cmp		al, CR
+	jne		SHORT .NotCarriageReturn
+
+	; Select item
 	mov		cx, [bp+MENUINIT.wHighlightedItem]
 	call	MenuEvent_ItemSelectedFromCX
 	stc
-	ret
+.Return:
+	ret
+
+ALIGN MENU_JUMP_ALIGN
+.NotCarriageReturn:
+	test	BYTE [bp+MENU.bFlags], FLG_MENU_USER_HANDLES_SCROLLING
+	jnz		SHORT .Return	; With CF cleared since keystroke not processed
+	; Fall to MenuLoop_ProcessScrollingKeysFromAX
 
 
@@ -172,8 +174,7 @@
 .ChangeToPreviousPage:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
-	xchg	ax, cx
-	neg		ax
-	mov		cx, [bp+MENUINIT.wHighlightedItem]
-	add		cx, ax
+	neg		cx
+	mov		ax, cx
+	add		cx, [bp+MENUINIT.wHighlightedItem]
 	jge		SHORT .MoveHighlightedItemByAX	; No rotation for PgUp
 	; Fall to .SelectFirstItem
@@ -187,7 +188,6 @@
 .ChangeToNextPage:
 	call	MenuScrollbars_GetMaxVisibleItemsOnPageToCX
-	xchg	ax, cx
-	mov		cx, [bp+MENUINIT.wHighlightedItem]
-	add		cx, ax
+	mov		ax, cx
+	add		cx, [bp+MENUINIT.wHighlightedItem]
 	cmp		cx, [bp+MENUINIT.wItems]
 	jb		SHORT .MoveHighlightedItemByAX	; No rotation for PgDn
Index: /trunk/Assembly_Library/Src/Serial/SerialServerScan.asm
===================================================================
--- /trunk/Assembly_Library/Src/Serial/SerialServerScan.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Serial/SerialServerScan.asm	(revision 589)
@@ -46,16 +46,15 @@
 
 		test	dx, dx
-		jnz		short SerialServerScan_CheckForServer_PortAndBaudInDX
+		jnz		SHORT SerialServerScan_CheckForServer_PortAndBaudInDX
 
-		mov		di,.scanPortAddresses-1
-		mov		ch,1			;  tell server that we are scanning
+		mov		di, .scanPortAddresses-1
+		mov		ch, 1			;  tell server that we are scanning
 
 .nextPort:
 		inc		di				; load next port address
-		xor		dh, dh
-		mov		dl,[cs:di]
+		mov		dh, 40h			; Clear DH and make sure CF is set if error
+		mov		dl, [cs:di]
 		eSHL_IM	dx, 2			; shift from one byte to two
-		stc						; setup error code for exit
-		jz		.error
+		jz		SHORT .error
 
 ;
@@ -63,17 +62,17 @@
 ;
 		push	dx
-		add		dl,Serial_UART_lineControl
-		mov		al, 09ah
+		add		dl, Serial_UART_lineControl
+		mov		al, 9Ah
 		out		dx, al
 		in		al, dx
 		pop		dx
-		cmp		al, 09ah
-		jnz		.nextPort
+		cmp		al, 9Ah
+		jne		SHORT .nextPort
 
-		mov		al, 0ch
+		mov		al, 0Ch
 		out		dx, al
 		in		al, dx
-		cmp		al, 0ch
-		jnz		.nextPort
+		cmp		al, 0Ch
+		jne		SHORT .nextPort
 
 ;
@@ -84,22 +83,22 @@
 ; *on the server side* if the client side had a 4x clock multiplier, a 2x clock multiplier, or no clock multiplier.
 ;
-; Starting with 30h, that means 30h (2400 baud), 18h (4800 baud), 0ch (9600 baud), and
+; Starting with 30h, that means 30h (2400 baud), 18h (4800 baud), 0Ch (9600 baud), and
 ;					            04h (28800 baud), 02h (57600 baud), 01h (115200 baud)
 ;
-; Note: hardware baud multipliers (2x, 4x) will impact the final baud rate and are not known at this level
+; Note: hardware baud multipliers (2x, 4x, 8x) will impact the final baud rate and are not known at this level
 ;
-		mov		dh,030h * 2		; multiply by 2 since we are about to divide by 2
-		mov		dl,[cs:di]		; restore single byte port address for scan
+		mov		dh, 30h * 2		; multiply by 2 since we are about to divide by 2
+		mov		dl, [cs:di]		; restore single byte port address for scan
 
 .nextBaud:
-		shr		dh,1
-		jz		.nextPort
-		cmp		dh,6			; skip from 6 to 4, to move from the top of the 9600 baud range
-		jnz		.testBaud		; to the bottom of the 115200 baud range
-		mov		dh,4
+		shr		dh, 1
+		jz		SHORT .nextPort
+		cmp		dh, 6			; skip from 6 to 4, to move from the top of the 9600 baud range
+		jne		SHORT .testBaud	; to the bottom of the 115200 baud range
+		mov		dh, 4
 
 .testBaud:
 		call	SerialServerScan_CheckForServer_PortAndBaudInDX
-		jc		.nextBaud
+		jc		SHORT .nextBaud
 
 .error:
@@ -135,15 +134,11 @@
 SerialServerScan_CheckForServer_PortAndBaudInDX:
 		push	bp				; setup fake SerialServer_Command
-
 		push	dx				; send port baud and rate, returned in inquire packet
 								; (and possibly returned in the drive identification string)
-
 		push	cx				; send number of sectors, and if it is on a scan or not
-
-		mov		bl,SerialServer_Command_Inquire			; protocol command onto stack with bh
+		mov		bl, SerialServer_Command_Inquire		; protocol command onto stack with bh
 		push	bx
 
-		mov		bp,sp
-
+		mov		bp, sp
 		call	SerialServer_SendReceive
 
Index: /trunk/Assembly_Library/Src/Util/Math.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Math.asm	(revision 588)
+++ /trunk/Assembly_Library/Src/Util/Math.asm	(revision 589)
@@ -36,4 +36,5 @@
 ALIGN JUMP_ALIGN
 Math_DivQWatSSBPbyCX:
+%if 1
 	xor		dx, dx
 	mov		ax, [bp+6]		; Load highest divident WORD to DX:AX
@@ -53,4 +54,19 @@
 	mov		[bp], ax
 	ret
+%else ; ~1
+; This is about half the size compared to the above code but it's not tested which is why it's commented away.
+	push	di
+	mov		di, 6
+	xor		dx, dx
+.Next:
+	mov		ax, [bp+di]
+	div		cx
+	mov		[bp+di], ax
+	dec		di
+	dec		di
+	jns		.Next
+	pop		di
+	ret
+%endif ; 1
 %endif
 
Index: /trunk/BIOS_Drive_Information_Tool/Src/Bios.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Bios.asm	(revision 588)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Bios.asm	(revision 589)
@@ -146,13 +146,8 @@
 	mov		bx, 55AAh
 	int		BIOS_DISK_INTERRUPT_13h
-	jc		SHORT .NoEbiosPresent
-	cmp		bx, 0AA55h
-	jne		SHORT .NoEbiosPresent
-	eMOVZX	bx, ah			; Copy version to BX
-	xor		ah, ah
-	ret
-.NoEbiosPresent:
-	mov		ah, RET_HD_INVALID
-	stc
+	jc		SHORT ReturnInvalidErrorCodeInAH	; No EBIOS present
+	xor		bx, 0AA55h
+	jnz		SHORT ReturnInvalidErrorCodeInAH	; No EBIOS present
+	xchg	bl, ah			; Version to BX, BIOS error code to AH
 	ret
 
Index: /trunk/BIOS_Drive_Information_Tool/Src/Main.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Main.asm	(revision 588)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Main.asm	(revision 589)
@@ -60,10 +60,5 @@
 	mov		si, g_szProgramName
 	call	Print_NullTerminatedStringFromSI
-
-	call	ReadAndDisplayAllHardDrives
-
-	; Exit to DOS
-	mov 	ax, 4C00h			; Exit to DOS
-	int 	21h
+	; Fall to ReadAndDisplayAllHardDrives
 
 
@@ -112,5 +107,5 @@
 	loop	.DisplayNextDriveFromDL
 .NoDrivesAvailable:
-	ret
+	ret		; Exit to DOS
 
 
Index: /trunk/BIOS_Drive_Information_Tool/Src/Print.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 588)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 589)
@@ -42,8 +42,6 @@
 ;	Parameters:
 ;		AL:		Character to output
-;		DS:		BDA segment (zero)
-;		ES:DI:	Ptr to video memory where to output
-;	Returns:
-;		DI:		Incremented for next character
+;	Returns:
+;		Nothing
 ;	Corrupts registers:
 ;		AX, DX
@@ -51,6 +49,6 @@
 DosCharOut:
 	xchg	dx, ax
-	mov		ah, 02h		; DOS 1+ - WRITE CHARACTER TO STANDARD OUTPUT
-	int		21h			; Call DOS
+	mov		ah, WRITE_CHARACTER_TO_STANDARD_OUTPUT
+	int		DOS_INTERRUPT_21h
 	ret
 
Index: /trunk/Serial_Server/library/Checksum.cpp
===================================================================
--- /trunk/Serial_Server/library/Checksum.cpp	(revision 588)
+++ /trunk/Serial_Server/library/Checksum.cpp	(revision 589)
@@ -3,5 +3,5 @@
 // Project:     XTIDE Universal BIOS, Serial Port Server
 //
-// File:        checksum.cpp - Checksum function and test routines
+// File:        Checksum.cpp - Checksum function and test routines
 
 //
@@ -39,5 +39,5 @@
 //
 
-#include "library.h"
+#include "Library.h"
 
 unsigned short checksum( unsigned short *wbuff, int wlen )
Index: /trunk/Serial_Server/library/File.h
===================================================================
--- /trunk/Serial_Server/library/File.h	(revision 588)
+++ /trunk/Serial_Server/library/File.h	(revision 589)
@@ -3,5 +3,5 @@
 // Project:     XTIDE Universal BIOS, Serial Port Server
 //
-// File:        file.h - File access via standard "stdio.h" routines
+// File:        File.h - File access via standard "stdio.h" routines
 //
 // Routines for accessing the file system using generic routines, which
Index: /trunk/Serial_Server/library/FlatImage.h
===================================================================
--- /trunk/Serial_Server/library/FlatImage.h	(revision 588)
+++ /trunk/Serial_Server/library/FlatImage.h	(revision 589)
@@ -22,5 +22,5 @@
 //
 
-#include "library.h"
+#include "Library.h"
 
 class FlatImage : public Image
Index: /trunk/Serial_Server/library/Image.cpp
===================================================================
--- /trunk/Serial_Server/library/Image.cpp	(revision 588)
+++ /trunk/Serial_Server/library/Image.cpp	(revision 589)
@@ -3,5 +3,5 @@
 // Project:     XTIDE Universal BIOS, Serial Port Server
 //
-// File:        image.cpp - Abstract base class for disk image support
+// File:        Image.cpp - Abstract base class for disk image support
 //
 
@@ -22,5 +22,5 @@
 //
 
-#include "library.h"
+#include "Library.h"
 #include <memory.h>
 #include <stdlib.h>
Index: /trunk/Serial_Server/library/Library.h
===================================================================
--- /trunk/Serial_Server/library/Library.h	(revision 588)
+++ /trunk/Serial_Server/library/Library.h	(revision 589)
@@ -3,5 +3,5 @@
 // Project:     XTIDE Universal BIOS, Serial Port Server
 //
-// File:        library.h - Include file for users of the library
+// File:        Library.h - Include file for users of the library
 //
 
@@ -87,5 +87,5 @@
 
 #ifdef WIN32
-#include "../win32/win32serial.h"
+#include "../win32/Win32Serial.h"
 #else
 // there is no standard way to read/write and configure the serial port, OS specific only
@@ -93,7 +93,7 @@
 
 #ifdef WIN32
-#include "../win32/win32file.h"
+#include "../win32/Win32File.h"
 #else
-#include "file.h"
+#include "File.h"
 #endif
 
Index: /trunk/Serial_Server/library/Process.cpp
===================================================================
--- /trunk/Serial_Server/library/Process.cpp	(revision 588)
+++ /trunk/Serial_Server/library/Process.cpp	(revision 589)
@@ -3,5 +3,5 @@
 // Project:     XTIDE Universal BIOS, Serial Port Server
 //
-// File:        process.cpp - Processes commands received over the serial port
+// File:        Process.cpp - Processes commands received over the serial port
 //
 
@@ -22,5 +22,5 @@
 //
 
-#include "library.h"
+#include "Library.h"
 #include <memory.h>
 #include <string.h>
Index: /trunk/Serial_Server/library/Serial.cpp
===================================================================
--- /trunk/Serial_Server/library/Serial.cpp	(revision 588)
+++ /trunk/Serial_Server/library/Serial.cpp	(revision 589)
@@ -22,5 +22,5 @@
 //
 
-#include "library.h"
+#include "Library.h"
 #include <stdlib.h>
 #include <string.h>
Index: /trunk/Serial_Server/makefile
===================================================================
--- /trunk/Serial_Server/makefile	(revision 588)
+++ /trunk/Serial_Server/makefile	(revision 589)
@@ -11,5 +11,5 @@
 #
 
-HEADERS = library/library.h win32/win32file.h win32/win32serial.h library/file.h library/flatimage.h
+HEADERS = library/Library.h win32/Win32File.h win32/Win32Serial.h library/File.h library/FlatImage.h
 
 CXX = cl
@@ -21,18 +21,18 @@
 	@$(CXX) /Febuild/serdrive.exe $(WIN32OBJS)
 
-build/win32.obj:	win32/win32.cpp $(HEADERS)
-	@$(CXX) /c $(CXXFLAGS) win32/win32.cpp /Fobuild/win32.obj
+build/win32.obj:	win32/Win32.cpp $(HEADERS)
+	@$(CXX) /c $(CXXFLAGS) win32/Win32.cpp /Fobuild/win32.obj
 
-build/checksum.obj:	library/checksum.cpp $(HEADERS)
-	@$(CXX) /c $(CXXFLAGS) library/checksum.cpp /Fobuild/checksum.obj
+build/checksum.obj:	library/Checksum.cpp $(HEADERS)
+	@$(CXX) /c $(CXXFLAGS) library/Checksum.cpp /Fobuild/checksum.obj
 
-build/serial.obj:	library/serial.cpp $(HEADERS)
-	@$(CXX) /c $(CXXFLAGS) library/serial.cpp /Fobuild/serial.obj
+build/serial.obj:	library/Serial.cpp $(HEADERS)
+	@$(CXX) /c $(CXXFLAGS) library/Serial.cpp /Fobuild/serial.obj
 
-build/process.obj:	library/process.cpp $(HEADERS)
-	@$(CXX) /c $(CXXFLAGS) library/process.cpp /Fobuild/process.obj
+build/process.obj:	library/Process.cpp $(HEADERS)
+	@$(CXX) /c $(CXXFLAGS) library/Process.cpp /Fobuild/process.obj
 
-build/image.obj:	library/image.cpp $(HEADERS)
-	@$(CXX) /c $(CXXFLAGS) library/image.cpp /Fobuild/image.obj
+build/image.obj:	library/Image.cpp $(HEADERS)
+	@$(CXX) /c $(CXXFLAGS) library/Image.cpp /Fobuild/image.obj
 
 
@@ -46,5 +46,5 @@
 
 
-build/checksum_test.exe:	library/checksum.cpp
-	@$(CXX) /Febuild/checksum_test.exe /Ox library/checksum.cpp /Fobuild/checksum_test.obj -D CHECKSUM_TEST
+build/checksum_test.exe:	library/Checksum.cpp
+	@$(CXX) /Febuild/checksum_test.exe /Ox library/Checksum.cpp /Fobuild/checksum_test.obj -D CHECKSUM_TEST
 
Index: /trunk/Serial_Server/win32/Win32.cpp
===================================================================
--- /trunk/Serial_Server/win32/Win32.cpp	(revision 588)
+++ /trunk/Serial_Server/win32/Win32.cpp	(revision 589)
@@ -30,8 +30,8 @@
 #include <stdarg.h>
 
-#include "../library/library.h"
-#include "../library/flatimage.h"
-
-#include "../../XTIDE_Universal_BIOS/inc/version.inc"
+#include "../library/Library.h"
+#include "../library/FlatImage.h"
+
+#include "../../XTIDE_Universal_BIOS/Inc/Version.inc"
 
 char *bannerStrings[] = {
Index: /trunk/Serial_Server/win32/Win32File.h
===================================================================
--- /trunk/Serial_Server/win32/Win32File.h	(revision 588)
+++ /trunk/Serial_Server/win32/Win32File.h	(revision 589)
@@ -29,5 +29,5 @@
 #include <windows.h>
 #include <stdio.h>
-#include "../library/library.h"
+#include "../library/Library.h"
 
 class FileAccess
Index: /trunk/Serial_Server/win32/Win32Serial.h
===================================================================
--- /trunk/Serial_Server/win32/Win32Serial.h	(revision 588)
+++ /trunk/Serial_Server/win32/Win32Serial.h	(revision 589)
@@ -24,5 +24,5 @@
 #include <stdio.h>
 #include "windows.h"
-#include "../library/library.h"
+#include "../library/Library.h"
 
 #define PIPENAME "\\\\.\\pipe\\xtide"
Index: /trunk/XTIDE_Universal_BIOS/Inc/Controllers/AdvancedID.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/Controllers/AdvancedID.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/Controllers/AdvancedID.inc	(revision 589)
@@ -32,7 +32,7 @@
 ; Vision
 ; QDI Vision Controller Identification nibbles used by hardware so do not modify these
-ID_QD6580_ALTERNATE			EQU		5
-ID_QD6580					EQU		10
-ID_QD6500					EQU		12
+ID_QD6580_ALTERNATE			EQU		80
+ID_QD6580					EQU		160
+ID_QD6500					EQU		192
 
 
Index: /trunk/XTIDE_Universal_BIOS/Inc/Controllers/PDC20x30.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/Controllers/PDC20x30.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/Controllers/PDC20x30.inc	(revision 589)
@@ -2,6 +2,4 @@
 ; Description	:	Promise PDC 20230-C and 20630 VLB IDE controller
 ;					specifications.
-;
-;					Specifications can be found at 
 
 ;
Index: /trunk/XTIDE_Universal_BIOS/Inc/Controllers/XTCF.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/Controllers/XTCF.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/Controllers/XTCF.inc	(revision 589)
@@ -56,8 +56,8 @@
 ; the mode via a call to Int 13h function 1Eh accordingly (see AH1Eh_XTCF.asm).
 ;
-XTCF_8BIT_PIO_MODE					EQU		0	; XT-CF using 8-bit PIO mode
-XTCF_8BIT_PIO_MODE_WITH_BIU_OFFLOAD	EQU		1	; XT-CF using 8-bit PIO mode, but with 16-bit instructions
-XTCF_16BIT_PIO_WITH_BIU_OFFLOAD		EQU		2	; Lo-tech 8-bit IDE Adapter
-XTCF_DMA_MODE						EQU		3	; XT-CFv3 using DMA
+XTCF_8BIT_PIO_MODE						EQU		0	; XT-CF using 8-bit PIO mode
+XTCF_8BIT_PIO_MODE_WITH_BIU_OFFLOAD		EQU		1	; XT-CF using 8-bit PIO mode, but with 16-bit instructions
+XTCF_16BIT_PIO_MODE_WITH_BIU_OFFLOAD	EQU		2	; Lo-tech 8-bit IDE Adapter
+XTCF_DMA_MODE							EQU		3	; XT-CFv3 using DMA
 
 
Index: /trunk/XTIDE_Universal_BIOS/Inc/CustomDPT.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/CustomDPT.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/CustomDPT.inc	(revision 589)
@@ -84,5 +84,5 @@
 
 
-	; Flags for DPT_ADVANCED_ATA.bInitError
+	; Flags for DPT.bInitError
 	FLG_INITERROR_FAILED_TO_SELECT_DRIVE				EQU (1<<0)
 	FLG_INITERROR_FAILED_TO_INITIALIZE_CHS_PARAMETERS	EQU (1<<1)
Index: /trunk/XTIDE_Universal_BIOS/Inc/IDE_8bit.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/IDE_8bit.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/IDE_8bit.inc	(revision 589)
@@ -21,46 +21,4 @@
 %ifndef IDE_8BIT_INC
 %define IDE_8BIT_INC
-
-;--------------------------------------------------------------------
-; UNROLL_SECTORS_IN_CX_TO_DWORDS
-; UNROLL_SECTORS_IN_CX_TO_QWORDS
-; UNROLL_SECTORS_IN_CX_TO_OWORDS
-;	Parameters:
-;		CX:		Number of sectors in block
-;	Returns:
-;		CX:		Number of DWORDs, QWORDs or OWORDs in block
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
-%macro UNROLL_SECTORS_IN_CX_TO_DWORDS 0
-%ifdef USE_186
-	shl		cx, 7
-%else
-	xchg	cl, ch		; Sectors to WORDs (SHL CX, 8)
-	shr		cx, 1
-%endif
-%endmacro
-
-%macro UNROLL_SECTORS_IN_CX_TO_QWORDS 0
-%ifdef USE_186
-	shl		cx, 6
-%else
-	UNROLL_SECTORS_IN_CX_TO_DWORDS
-	shr		cx, 1
-%endif
-%endmacro
-
-%macro UNROLL_SECTORS_IN_CX_TO_OWORDS 0
-%ifdef USE_186
-	shl		cx, 5
-%else
-;	UNROLL_SECTORS_IN_CX_TO_QWORDS
-;	shr		cx, 1
-	mov		ch, cl		; 2 bytes shorter but possibly slower
-	mov		cl, 3
-	shr		cx, cl
-%endif
-%endmacro
-
 
 ;--------------------------------------------------------------------
Index: /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc	(revision 589)
@@ -105,3 +105,45 @@
 
 
+;--------------------------------------------------------------------
+; UNROLL_SECTORS_IN_CX_TO_DWORDS
+; UNROLL_SECTORS_IN_CX_TO_QWORDS
+; UNROLL_SECTORS_IN_CX_TO_OWORDS
+;	Parameters:
+;		CX:		Number of sectors in block
+;	Returns:
+;		CX:		Number of DWORDs, QWORDs or OWORDs in block
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+%macro UNROLL_SECTORS_IN_CX_TO_DWORDS 0
+%ifdef USE_186
+	shl		cx, 7
+%else
+	xchg	cl, ch		; Sectors to WORDs (SHL CX, 8)
+	shr		cx, 1
+%endif
+%endmacro
+
+%macro UNROLL_SECTORS_IN_CX_TO_QWORDS 0
+%ifdef USE_186
+	shl		cx, 6
+%else
+	UNROLL_SECTORS_IN_CX_TO_DWORDS
+	shr		cx, 1
+%endif
+%endmacro
+
+%macro UNROLL_SECTORS_IN_CX_TO_OWORDS 0
+%ifdef USE_186
+	shl		cx, 5
+%else
+;	UNROLL_SECTORS_IN_CX_TO_QWORDS
+;	shr		cx, 1
+	mov		ch, cl		; 2 bytes shorter but possibly slower
+	mov		cl, 3
+	shr		cx, cl
+%endif
+%endmacro
+
+
 %endif ; IDE_IO_INC
